<?php    

namespace Concrete\Package\Grouptextpro;
use Package;
use BlockType;
use SinglePage;
use Loader;
use Config;

defined('C5_EXECUTE') or die(_("Access Denied."));

class Controller extends Package {

	protected $pkgHandle = 'grouptextpro';
	protected $appVersionRequired = '5.7.4';
	protected $pkgVersion = '2.2';
	
	public function getPackageDescription() {
		return t('Send bulk SMS messages with grouptext.pro');
	}
	
	public function getPackageName() {
		return t('Group Text Pro');
	}

    public function registerHelpers() {
        \Core::bind('grouptextpro/api', function() {
            return new \Concrete\Package\Grouptextpro\Src\Api();
        });
        \Core::bind('grouptextpro/tools', function() {
            return new \Concrete\Package\Grouptextpro\Src\Tools();
        });
    }
    
    public function registerRoutes() {
        \Route::register('/grouptextpro/ajax', '\Concrete\Package\Grouptextpro\Src\Ajax::in');        
    }
    
    public function on_start() {
        $this->registerHelpers();
        $this->registerRoutes();
    }
    
	public function install() {
		$pkg = parent::install();

		// install block		
		BlockType::installBlockTypeFromPackage('grouptextpro', $pkg);		        

		$pageLanding = SinglePage::add('/dashboard/grouptextpro', $pkg);
    	$pageLanding->update(array('cName' => t('Group Text Pro'), 'cDescription' => t('Send bulk text messages.'))); 
		$pageSend = SinglePage::add('/dashboard/grouptextpro/send', $pkg);
    	$pageSend->update(array('cName' => t('Send'), 'cDescription' => t('Manage your account.'))); 
		$pageMessages = SinglePage::add('/dashboard/grouptextpro/messages', $pkg);
    	$pageMessages->update(array('cName' => t('Messages'), 'cDescription' => t('Manage your messages.'))); 
		$pageGroups = SinglePage::add('/dashboard/grouptextpro/groups', $pkg);
    	$pageGroups->update(array('cName' => t('Groups'), 'cDescription' => t('Manage your groups.'))); 
		$pageContacts = SinglePage::add('/dashboard/grouptextpro/contacts', $pkg);
    	$pageContacts->update(array('cName' => t('Contacts'), 'cDescription' => t('Manage your contacts.'))); 
		$pageAccount = SinglePage::add('/dashboard/grouptextpro/account', $pkg);
    	$pageAccount->update(array('cName' => t('Account'), 'cDescription' => t('Manage your account.'))); 

	}
	
	public function upgrade(){
		parent::upgrade(); 
	}

	public function uninstall(){
        \Core::make('grouptextpro/tools')->clearConfig();
       
        $pkg = parent::uninstall();
  	}
}
?>