<?php 

    namespace Concrete\Package\Grouptextpro\Controller\SinglePage\Dashboard\GroupTextPro;
    use \Concrete\Core\Page\Controller\DashboardPageController;
    use Config;
    use Loader;
    use Package;
    use Session;

    defined('C5_EXECUTE') or die("Access Denied.");

    class Account extends DashboardPageController {
        
        function view() {
            $gtp = \Core::make('grouptextpro/tools');
            $gtp->refreshUserDetails();
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->plan_detail();
            if($json->status=="success") {
                $this->set('plan',$json->plan);
                $this->set('planGroup',$json->planGroup);                
                $this->set('pageTitle',t('Account Detail'));
            } else {
                $this->set('what','register');
                $this->set('pageTitle',t('Create A New GroupText.pro Account'));
            }
            define('GTP_IS_ACCOUNT_PAGE',true);
        }
        
        function edit($message=false) {
            $this->set('what','edit');
            $this->set('pageTitle',t('Edit Your Account'));
            if($message) {
                $this->set('message',$message);
            }
        }
        
        function existing() {
            $this->set('what','existing');
            $this->set('pageTitle',t('Log In To GroupText.pro'));
        }
        
        function cancel() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->plan_cancel();
            $this->redirect('dashboard/grouptextpro/account/canceled');
        }
        
        function canceled() {
            $this->view();
        }

        function login() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->user_login(array(
                'e'=>$_REQUEST['e'],
                'p'=>$_REQUEST['p']
            ));
            if($json->status=="success") {
                \Core::make('grouptextpro/tools')->saveConfig($json->user->id,$json->user->conf);
                $this->redirect('dashboard/grouptextpro/account');                
            } else {
                $this->set('message',$json->error->msg);
                $this->existing();
            }
            
        }

        function plan_change($id) {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->plan_change(array(
                'id'=>$id
            ));
            if($json->status=="success") {
                $this->redirect('dashboard/grouptextpro/account/plan_changed');                
            } else {
                $this->set('message',$json->error->msg);                                
                $this->plans();
            }
        }
        
        function plan_changed() {
            $this->view();
        }

        function plans() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->plan_detail();
            $this->set('plan',$json->plan);
            $this->set('planGroup',$json->planGroup);
            $this->set('what','plans');
            $this->set('pageTitle',t('Select New Plan'));
        }
        
        function register() {
            $sendToApi = true; // reset if there are errors in validations

            // sanitize
            $_REQUEST['zip'] = str_replace(' ','',$_REQUEST['zip']);
            
            // check password against confirm
            if($_REQUEST['password']<>$_REQUEST['password2']) {
                $this->set('message',t('Your passwords do not match.'));
                $sendToApi = false;
            }
            
            // API call
            if($sendToApi) {
                $api = \Core::make('grouptextpro/api'); 
                $json = $api->customer_create(array(
                    'name'=>$_REQUEST['name'],
                    'website'=>$_REQUEST['website'],
                    'fname'=>$_REQUEST['fname'],
                    'lname'=>$_REQUEST['lname'],
                    'email'=>$_REQUEST['email'],
                    'password'=>$_REQUEST['password'],
                    'zip'=>$_REQUEST['zip']
                ));
                
                if($json->status=="success") {
                    // set the config vars
                    \Core::make('grouptextpro/tools')->saveConfig($json->user->id,$json->user->conf); 
                    $this->redirect('dashboard/grouptextpro/account');               
                } else {
                    $this->set('message',$json->error->msg);
                }
            }
            
            $this->view();
        }
        
        function save() {
            
            $data = array(
                'name'=>$_REQUEST['name'],
                'website'=>$_REQUEST['website'],
                'fname'=>$_REQUEST['fname'],
                'lname'=>$_REQUEST['lname'],
                'email'=>$_REQUEST['email'],
                'zip'=>$_REQUEST['zip'],
            );
            
            if(
                strlen($_REQUEST['password']) && 
                strlen($_REQUEST['password2'])
            ) {
                if($_REQUEST['password'] == $_REQUEST['password2']) {
                    $data['password'] = $_REQUEST['password'];                    
                }  else {
                    
                }            
            }
            
            
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->user_update($data);
            if($json->status=="success") {
                $this->redirect('dashboard/grouptextpro/account/saved');
            } else {
                $this->set('message',$json->error->msg);
                $this->edit();
            }
            
        }
        
        function saved() {
            $this->set('message',t('Your account details have been updated.'));
            $this->view();
        }
        
        function unlink() {
            \Core::make('grouptextpro/tools')->unlinkAccount(); 
            $this->redirect('dashboard/grouptextpro/account/unlinked');
        }
                        
        function unlinked() {
            $this->set('message',t('Your account has been unlinked from this website.'));
            $this->view();
        }
    }