<?php 

    namespace Concrete\Package\Grouptextpro\Controller\SinglePage\Dashboard\GroupTextPro;
    use \Concrete\Core\Page\Controller\DashboardPageController;
    use Loader;
    use Package;

    defined('C5_EXECUTE') or die("Access Denied.");

    class Contacts extends DashboardPageController {
        
        function view() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->contacts_list();
            $this->set('contacts',$json->contacts);
            $this->set('pageTitle',t('Contacts List'));
        }
        
        function contact($id) {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->contact_detail(array(
                'id'=>$id,
                'groups'=>'all',
            ));
            if($json->status=="success") {
                $ct = $json->contact;
                $this->set('contact',$ct);
                $this->set('what','contact');
                $this->set('pageTitle',t('Contact Details: ') . (strlen($ct->names->fl)?$ct->names->fl:$ct->phoneFormatted));
                
                // get the messages
                $json = $api->contact_messages(array(
                    'id'=>$id,
                ));
                $this->set('messages',$json->messages);
                
            } else {
                $this->redirect('dashboard/grouptextpro/contacts');
                exit;
            }
        }

        function add() {
            $this->set('what','add');            
            $this->set('pageTitle',t('Add Contact'));
        }
        
        function create() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->contact_add(array(
                'phone'=>$_POST['phone'],
                'fname'=>$_POST['fname'],
                'lname'=>$_POST['lname'],
                'organization'=>$_POST['organization'],
            ));
            if($json->status=="success") {
                $this->redirect('dashboard/grouptextpro/contacts/contact/'.$json->contact->id);
            } else {
                $this->set('message',$json->error->msg);
                $this->add();
            }            
        }
        
        function edit($id) {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->contact_detail(array(
                'id'=>$id
            ));
            if($json->status=="success") {
                $ct = $json->contact;
                $this->set('contact',$ct);
                $this->set('what','edit');
                $this->set('pageTitle',t('Edit Contact: ') . (strlen($ct->names->fl)?$ct->names->fl:$ct->phoneFormatted));
            } else {
                $this->message(t('We could not find your contact.'));
                exit;
            }            
        }
        
        function save() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->contact_update(array(
                'id'=>$_POST['id'],
                'phone'=>$_POST['phone'],
                'fname'=>$_POST['fname'],
                'lname'=>$_POST['lname'],
                'organization'=>$_POST['organization'],
            ));
            if($json->status=="success") {
                $this->redirect('dashboard/grouptextpro/contacts/contact/'.$json->contact->id);
            } else {
                $this->redirect('dashboard/grouptextpro/contacts/contact/'.$json->contact->id);
            }            
        }
        
        function import($do="") {
            switch($do) {
                case "upload":
                    $tmpName = $_FILES["csvFile"]["tmp_name"];
                    if(!$tmpName) {
                        $this->set('message',t('The upload was not successful.'));
                    } else {
                        $content = file_get_contents($tmpName);
                        if(!strlen($content)) {
                            $this->set('message',t('We could not read your file.'));
                        } else {
                            $api = \Core::make('grouptextpro/api');
                            $json = $api->contacts_csv(array(
                                "groupIDs"=>$_POST['groupIDs'],
                                "csv"=>$content,
                                "filename",$_FILES["csvFile"]["name"]
                            ));      
                            if($json->status=="success") {
                                $this->set('message',t('Your file was uploaded and will be processed soon.'));
                            } else {
                                $this->set('message',t('There was an issue and we were not able to upload your data to the server.'));                                
                            }                   
                        }                        
                    }
                    break;
            }
            \Core::make('grouptextpro/tools')->refreshUserDetails();
            $this->set('what','import');
            $this->set('pageTitle',t('Import Contacts via CSV (Excel)'));
        }

    }