<?php 

    namespace Concrete\Package\Grouptextpro\Controller\SinglePage\Dashboard\GroupTextPro;
    use \Concrete\Core\Page\Controller\DashboardPageController;
    use Loader;
    use Package;

    defined('C5_EXECUTE') or die("Access Denied.");

    class Groups extends DashboardPageController {
        
        function view() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->groups_list();
            $this->set('groups',$json->groups);
            $this->set('pageTitle',t('Groups List'));
        }
        
        function add() {
            $this->set('what','add');            
            $this->set('pageTitle',t('Add A New Group'));
        }
        
        function create() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->group_add(array(
                'name'=>$_POST['name'],
                'keyword'=>$_POST['keyword'],
                'welcomeMessage'=>$_POST['welcomeMessage'],
            ));
            if($json->status=="success") {
                $this->redirect('dashboard/grouptextpro/groups/group/'.$json->group->id);
            } else {
                $this->message($json->error->msg);
                $this->add();
            }            
        }
        
        function edit($id) {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->group_detail(array(
                'id'=>$id
            ));
            if($json->status=="success") {
                $this->set('group',$json->group);
                $this->set('what','edit');
                $this->set('pageTitle',t('Edit Group: ') . $json->group->name);
            } else {
                $this->message(t('We could not find your group.'));
                $this->view();
            }            
        }
        
        function save() {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->group_update(array(
                'id'=>$_POST['id'],
                'name'=>$_POST['name'],
                'keyword'=>$_POST['keyword'],
                'welcomeMessage'=>$_POST['welcomeMessage'],
            ));
            if($json->status=="success") {
                $this->redirect('dashboard/grouptextpro/groups/group/'.$json->group->id);
            } else {
                $this->redirect('dashboard/grouptextpro/groups/group/'.$json->group->id);
            }            
        }
        
        function group($id) {
            $api = \Core::make('grouptextpro/api'); 
            $json = $api->group_detail(array(
                'id'=>$id,
                'contacts'=>'all'
            ));
            if($json->status=="success") {
                $this->set('group',$json->group);
                $this->set('what','group');
                $this->set('pageTitle',t('Group Detail: ').$json->group->name);
            } else {
                $this->redirect('dashboard/grouptextpro/groups');
                exit;
            }
        }

    }