<?php 
    defined('C5_EXECUTE') or die("Access Denied.");
    
    $form = Loader::helper('form'); 

    $dt = Loader::helper('form/date_time');
    $gtp = \Core::make('grouptextpro/tools');
    $gtpC = $gtp->getCustomer();
    $nowTimeLocal = new DateTime("now",$gtp->getUserTimezone());

?>
    <div class="row">
        <div class="col-sm-4 pull-right">
            <?php  View::element('send/shortUrl',array('form'=>$form),'grouptextpro'); ?>
        </div>
        <div class="col-sm-8">
        
       <form id="fmSend">
            <input type="hidden" name="what" value="send">
            <input type="hidden" name="groupIDs" id="hidGroupIDs" value="">

            <div class="row" style="margin-bottom: 1em;">
                <div class="col-sm-4">
                    <h4 style="margin-top: 0;"><strong><?php  echo t('Step 1'); ?></strong><br /><?php  echo t('Enter Your Message'); ?></h4>
                    <p><small><a href="#" onclick="$(this).next('span').toggleClass('hide'); return false;"><?php  echo t('Why only ') . $gtpC->message->lengthPerTextAvailable . t(' characters?'); ?></a> <span class="hide"><br /><?php  echo t('For compliance, we automatically add'); ?> <strong><?php  echo $gtpC->message->appendText; ?></strong> <?php  echo t('to each text. So your available space per text is ').'<strong>'.$gtpC->message->lengthPerTextAvailable.'</strong>'.t(' characters.%sMessages longer than ','<br />').$gtpC->message->lengthPerTextAvailable.t(' characters will still be sent successfully, but will use additional message credits.'); ?></span></small></p>
                </div>
                <div class="col-sm-8">
                    <p><?php  echo $form->textarea('message',false,array(
                        "style"=>"height: 100px;",
                        "onkeyup"=>"updateChars();",
                        "onchange"=>"updateChars();"
                    )); ?></p>
                    <div id="numChars" class="alert alert-success"></div>                
                </div>
            </div>
            
            <div class="row" style="margin-bottom: 1em;">
                <div class="col-sm-4">
                    <h4 style="margin-top: 0;"><strong><?php  echo t('Step 2'); ?></strong><br /><?php  echo t('Select The Groups To Send Your Message To'); ?></h4>                
                    <p><small><?php  echo t('Each phone number will be sent only one text message, even if it is in more than one group.'); ?></small></p>
                </div>
                <div class="col-sm-8">
                    <ul id="groupsList" class="nav nav-pills nav-stacked">
                        <?php  foreach($gtp->getGroups() AS $group) { ?>
                            <li id="group<?php  echo $group->id; ?>" group-id="<?php  echo $group->id; ?>"><a href="#" onclick="toggleGroup(<?php  echo $group->id; ?>); return false;"><?php  echo $group->name . " (" . $group->contacts->num->in . " " . ($group->contacts->num->in<>1?t('members'):t('member')); ?>)</a></li>
                        <?php  } ?>            
                    </ul>                
                </div>
            </div>
            
            <div class="row" style="margin-bottom: 1em;">
                <div class="col-sm-4">
                    <h4 style="margin-top: 0;"><strong><?php  echo t('Step 3'); ?></strong><br /><?php  echo t('Schedule Send (Optional)'); ?></h4>
                </div>
                <div class="col-sm-8">
                    <p><?php  echo t('By default, your texts will be queued for immediate sending. Or, you can %sschedule it for the future%s.','<a href="#" onclick="$(\'#scheduleWrap\').toggleClass(\'hide\'); return false;">','</a>'); ?></p>
            		<div id="scheduleWrap" class="input hide">                
                        <?php   print $dt->datetime('sendTime',$nowTimeLocal->format("Y-m-d H:i:s")); ?><br /><br />
                        <?php  echo t('Based on your zip code, we have your current time as %s. The message will be queued at your local time.','<strong>' . $nowTimeLocal->format("g:ia") . '</strong>'); ?>
                    </div>                
                </div>
            </div>
            
            <div class="row" style="margin-bottom: 1em;">
                <div class="col-sm-4">
                    <h4 style="margin-top:  0;"><strong><?php  echo t('Step 4'); ?></strong><br /><?php  echo t('Review Message'); ?></h4>
                </div>
                <div class="col-sm-8">
                    <a id="btnReviewSend" href="#" onclick="reviewSend(); return false;" class="btn btn-success"><?php  echo t('Review Message'); ?></a>                
                </div>
            </div>
                            
        </form>
                
        <div id="divSendReview" class="hide">
            <div class="row">
                <div class="col-sm-4">
                </div>
                <div class="col-sm-8">
                    <h3><?php  echo t('Message Review'); ?></h3>
                    <table class="table">
                        <tr>
                            <td style="width: 125px;"><strong><?php  echo t('Message'); ?></strong></td>
                            <td id="reviewMessage"></td>
                        </tr>
                        <tr>
                            <td><strong><?php  echo t('Groups'); ?></strong></td>
                            <td id="reviewGroupNames"></td>
                        </tr>
                        <tr>
                            <td><strong><?php  echo t('Contacts'); ?></strong></td>
                            <td id="reviewNumContacts"></td>
                        </tr>
                        <tr>
                            <td><strong><?php  echo t('Send Time'); ?></strong></td>
                            <td id="reviewSendTimeLocal"></td>
                        </tr>
                    </table>
                    <button class="btn btn-success" onclick="sendMessage();"><?php  echo t('Send This Message'); ?></button>
                    <button class="btn btn-danger" onclick="backToForm();"><?php  echo t('Back To Editing'); ?></button>
                </div>
        </div>
        
        </div>
    </div>
    
    <script type="text/javascript">
    
    function toggleGroup(id) {
        el = $('#group'+id);
        if(el.hasClass('active')) { el.removeClass('active'); } else { el.addClass('active'); }
    }
    
    function updateChars() {
        el = $('#numChars');
        numChars = $('#message').val().length;
        remainingChars = <?php  echo $gtpC->message->lengthPerTextAvailable; ?>-numChars;
        el.html("<?php  echo t('Characters entered: '); ?><strong>"+numChars+" / <?php  echo $gtpC->message->lengthPerTextAvailable; ?></strong>");
        $('#summaryMessage').html($('#message').val());
        if(remainingChars<0) {
            el.removeClass('alert-success').addClass('alert-warning');
            el.html(el.html()+' <?php  echo t('This message will use additional message credits.'); ?>');
        } else {
            el.removeClass('alert-warning').addClass('alert-success');
        }
    }
    $(function(){
        updateChars();
    })
    
    function backToForm() {
        $('#divSendReview').addClass('hide');
        $('#fmSend, #panelShortUrl').removeClass('hide');
    }
    
    function updateGroupIDs() {
        ids = "";
        $('#groupsList li.active').each(function(){
            ids = ids + "," + $(this).attr('group-id');
        })
        $('#hidGroupIDs').val(ids.substr(1));
    }

    function reviewSend() {
        $('#btnReviewSend').fadeOut();
        updateGroupIDs();
        $.ajax({
          dataType: "json",
          type: "GET",
          url: '<?php  echo Url::to('grouptextpro/ajax'); ?>?review=1',
          data: $('#fmSend').serialize(), 
          success: function(data) {
                if(data.success) {
                    $('#reviewMessage').html(data.message);
                    $('#reviewNumContacts').html(data.numContacts+' contact'+(data.numContacts!=1?'s':''));
                    $('#reviewSendTimeLocal').html(data.sendInFuture?data.sendTimeLocal:"Immediately");
                    $('#reviewGroupNames').html(data.groupNames);
                    $('#reviewTextsPerSend').html(data.textsPerSend);
                    $('#fmSend, #panelShortUrl').addClass('hide');
                    $('#divSendReview').removeClass('hide');
                } else {
                    alert(data.msg);
                }
                $('#btnReviewSend').fadeIn();
            }
        });
    }

    
    function sendMessage() {
        $('#btnSend').fadeOut();
        updateGroupIDs();
        $.ajax({
          dataType: "json",
          type: "POST",
          url: '<?php  echo Url::to('grouptextpro/ajax'); ?>?review=0',
          data: $('#fmSend').serialize(),
          success: function(data) {
                if(data.success) {
                    // go to message landing page
                    window.location.href="<?php  echo Url::to('dashboard/grouptextpro/messages/message'); ?>/"+data.message.id;
                } else {
                    alert(data.msg);
                    $('#btnSend').fadeIn();
                }
            }
        });
    }
    
    </script>