<?php  
    //namespace Concrete\Package\Grouptextpro\Helper;
    namespace Concrete\Package\Grouptextpro\Src;
    use Config;
    use Package;
    use \Concrete\Core\Http\Service\Json;

    defined('C5_EXECUTE') or die("Access Denied.");
      
    class Api {
        
        private $showApiUrl = false;
        
        private $apiVer = "1";
        private $apiBaseUrl = "https://api.grouptext.pro";
        private $apiConf = "";
        private $apiKey = "";
        private $params = array();
        private $debug = false;
        private $details = false;
        
        function getApiUrl() {
            return $this->apiBaseUrl."/".$this->apiVer."/";
        }
        
        function getUserID() {
            return Config::get('grouptextpro.user.id');
        }
        
        function getUserConf() {
            return Config::get('grouptextpro.user.conf');
        }
        
        function getConcrete5Version() {
            return Config::get('concrete.version');
        }
        
        function getPackageVersion() {
            return Package::getByHandle('grouptextpro')->getPackageVersion();
        }
        
        function clearParameters() {
            unset($this->params);
            $this->params = array();
        }
        
        function setParameter($key,$val) {
            $this->params[$key] = $val;
        }   
        
        function getDefaultParameters() {
            return array(
                'userID'=>$this->getUserID(),
                'userConf'=>$this->getUserConf(),
                'softwareID'=>5,
                'softwareVersion'=>$this->getConcrete5Version(),
                'addonVersion'=>$this->getPackageVersion(),
                'url'=>BASE_URL.DIR_REL
            );
        }
        function getParameters() {
            return array_merge($this->params,$this->getDefaultParameters());
        }
        
        function send() {
            //set POST variables
            $url = $this->getApiUrl();

            //url-ify the data for the POST
            $fields = $this->getParameters();
            foreach($fields AS $key=>$val) {
                if(is_array($val)) {
                    foreach($val AS $v) {
                        $fields_string .= $key."[]=".$v."&";
                    }    
                } else {
                    $fields_string .= $key.'='.$val.'&';                    
                }
            }
            rtrim($fields_string, '&');
            //open connection
            $ch = curl_init();
            if($this->showApiUrl) {
                echo $url."?".$fields_string;                 
            }
            
            //set the url, number of POST vars, POST data
            curl_setopt($ch,CURLOPT_URL, $url);
            curl_setopt($ch,CURLOPT_POST, count($fields));
            curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
                     
            //execute post
            $result = curl_exec($ch);
            
            //close connection
            curl_close($ch);  
            
            // handle an error where no value is returned 
            $result = strlen($result) ? $result : "{}";
            
            $return = Json::decode($result);
            return $return;

        }
        
        function __call($what,$args) {
            $this->clearParameters();            
            $this->setParameter('what',str_replace("_","-",$what));
            $params = $args[0];
            if(is_array($params)) {
                foreach($params AS $key=>$val) {
                    $this->setParameter($key,$val);            
                }                
            }
            return $this->send();
        }
        
    }
